#ifndef FORMATSCONFIG_H_INCLUDED
#define FORMATSCONFIG_H_INCLUDED

#include <qlabel.h>
#include <qvalidator.h>
#include <qdialog.h>
#include <qcombobox.h>

#include "configuration.h"
#include "configview.h"

class QPushButton;
class QListView;
class QListViewItem;
class FormatsListItem;
class PlaybackBackendConfigWidget;

class FormatsEditorDialog: public QDialog
{
	Q_OBJECT
public:
    FormatsEditorDialog(FormatsListItem *item, QWidget *parent = 0);
    int exec();

private slots:
	void usePlaybackBackendComboBoxCurrentIndexChanged(int index);

private:
	QVBoxLayout *configLayout_;
	int configIndex_;
	PlaybackBackendConfigWidget *configWidget_;
	QLineEdit *fileExtensionsLineEdit_;
	QComboBox *usePlaybackBackendComboBox_;
	FormatsListItem *item_;

	QString fixedUpFormatsString();
};

class FormatsConfig : public ConfigView
{
    Q_OBJECT
public:
    FormatsConfig(Configuration& configuration, QWidget *parent = 0) : ConfigView(configuration, parent) {}

    virtual void setStatesByConfiguration(const Configuration& config);
    virtual void saveStatesToConfiguration();

protected:
    virtual void createWidgets();

private slots:
    void editFormat(QListViewItem *);
    void editSelectedFormat();
    void addNewFormat();
    void removeSelectedFormat();
    void revertToDefaultFormats();

private:
    void readFromConfiguration(const Configuration& config);

    QPushButton *keyButton_;
    QListView *list_;
};

#endif // FORMATSCONFIG_H_INCLUDED
